//Language: AWK script 
//Copyright (c) 1992-2002 Altium Limited            
//All rights reserved.                              
//http://www.dream-com.com                          
//contact@dream-com.com                             

// states
State=snormal
State=sstring
State=scomment
// tokens
Token=tnone
Token=tstring
Token=tcomment
Token=tident
Token=tinteger
Token=tfloat
Token=tresword
Token=tassembler
Token=turl
Token=twhitespace
Token=tresword1
Token=tresword2
//delims
Delimiters=;.,:'"{}[]()?!@#$%^&*-+=|\/

// reswords
snormal 'BEGIN'      snormal tresword
snormal 'break'      snormal tresword
snormal 'continue'   snormal tresword
snormal 'do'         snormal tresword
snormal 'else'       snormal tresword
snormal 'END'        snormal tresword
snormal 'exit'       snormal tresword
snormal 'for'        snormal tresword
snormal 'function'   snormal tresword
snormal 'if'         snormal tresword
snormal 'in'         snormal tresword
snormal 'pattern'    snormal tresword
snormal 'return'     snormal tresword
snormal 'while'      snormal tresword

snormal 'ARGC'        snormal tresword1
snormal 'ARGIND'      snormal tresword1
snormal 'ARGV'        snormal tresword1
snormal 'CONVFMT'     snormal tresword1
snormal 'ENVIRON'     snormal tresword1
snormal 'ERRNO'       snormal tresword1
snormal 'FIELDWIDTHS' snormal tresword1
snormal 'FILENAME'    snormal tresword1
snormal 'FNR'         snormal tresword1
snormal 'FS'          snormal tresword1
snormal 'IGNORECASE'  snormal tresword1
snormal 'NF'          snormal tresword1
snormal 'NR'          snormal tresword1
snormal 'OFMT'        snormal tresword1
snormal 'OFS'         snormal tresword1
snormal 'ORS'         snormal tresword1
snormal 'RLENGTH'     snormal tresword1
snormal 'RS'          snormal tresword1
snormal 'RSTART'      snormal tresword1
snormal 'RT'          snormal tresword1
snormal 'SUBSEP'      snormal tresword1

snormal 'atan2'     snormal tresword2
snormal 'close'     snormal tresword2
snormal 'cos'       snormal tresword2
snormal 'exp'       snormal tresword2
snormal 'fflush'    snormal tresword2
snormal 'gensub'    snormal tresword2
snormal 'getline'   snormal tresword2
snormal 'gsub'      snormal tresword2
snormal 'index'     snormal tresword2
snormal 'int'       snormal tresword2
snormal 'length'    snormal tresword2
snormal 'log'       snormal tresword2
snormal 'match'     snormal tresword2
snormal 'next'      snormal tresword2
snormal 'nextfile'  snormal tresword2
snormal 'print'     snormal tresword2
snormal 'printf'    snormal tresword2
snormal 'rand'      snormal tresword2
snormal 'sin'       snormal tresword2
snormal 'split'     snormal tresword2
snormal 'sprintf'   snormal tresword2
snormal 'sqrt'      snormal tresword2
snormal 'srand'     snormal tresword2
snormal 'strftime'  snormal tresword2
snormal 'sub'       snormal tresword2
snormal 'substr'    snormal tresword2
snormal 'system'    snormal tresword2
snormal 'systime'   snormal tresword2
snormal 'tolower'   snormal tresword2
snormal 'toupper'   snormal tresword2

// numbers
snormal [1-9][0-9]*                            snormal  tinteger
snormal [1-9][0-9]*\.[0-9]*                    snormal  tfloat
snormal [1-9][0-9]*{\.[0-9]+}|e{[\+\-]}|[0-9]+ snormal  tfloat

//idents

snormal   [a-z_A-Z][a-z_A-Z0-9]*  snormal   tident

//white space
snormal #32*                      snormal   twhitespace

//comments
snormal    \#                      scomment  tcomment
scomment   [#1-#255]*              snormal   tcomment
scomment   $                       snormal   tcomment

//strings
snormal   \"                     sstring   tstring
sstring   [^\"]*                 sstring   tstring
sstring   \"                     snormal   tstring
sstring   \"\"                   sstring   tstring
sstring   \\                     sstring   tstring
sstring   \\\"                   sstring   tstring
sstring   $                      snormal   tstring
