//Language: RC file
//Copyright (c) 1992-2002 Altium Limited             
//All rights reserved.                               
//http://www.dream-com.com                           
//contact@dream-com.com                              

// states
State=snormal
State=sstring1
State=sstring2
State=scomment1
State=scomment2
State=sdirective
// tokens
Token=tnone
Token=tstring
Token=tcomment
Token=tident
Token=tinteger
Token=tfloat
Token=tresword
Token=tassembler
Token=turl
Token=twhitespace
Token=tdirective
//delims
Delimiters=;.,:'"{}[]()?!@#$%^&*-+=|\/

// reswords
snormal 'ACCELERATORS'    snormal tresword
snormal 'ALT'             snormal tresword
snormal 'ASCII'           snormal tresword
snormal 'AUTO3STATE'      snormal tresword
snormal 'AUTOCHECKBOX'    snormal tresword
snormal 'AUTORADIOBUTTON' snormal tresword
snormal 'BITMAP'          snormal tresword
snormal 'BLOCK'           snormal tresword
snormal 'CAPTION'         snormal tresword
snormal 'CHARACTERISTICS' snormal tresword
snormal 'CHECKBOX'        snormal tresword
snormal 'CHECKED'         snormal tresword
snormal 'CLASS'           snormal tresword
snormal 'COMBOBOX'        snormal tresword
snormal 'CONTROL'         snormal tresword
snormal 'CTEXT'           snormal tresword
snormal 'CURSOR'          snormal tresword
snormal 'DEFPUSHBUTTON'   snormal tresword
snormal 'DIALOG'          snormal tresword
snormal 'DIALOGEX'        snormal tresword
snormal 'DISCARDABLE'     snormal tresword
snormal 'DLGINIT'         snormal tresword
snormal 'EDITTEXT'        snormal tresword
snormal 'EXSTYLE'         snormal tresword
snormal 'FILEFLAGS'       snormal tresword
snormal 'FILEFLAGSMASK'   snormal tresword
snormal 'FILEOS'          snormal tresword
snormal 'FILESUBTYPE'     snormal tresword
snormal 'FILETYPE'        snormal tresword
snormal 'FILEVERSION'     snormal tresword
snormal 'FIXED'           snormal tresword
snormal 'FONT'            snormal tresword
snormal 'GRAYED'          snormal tresword
snormal 'GROUPBOX'        snormal tresword
snormal 'HELP'            snormal tresword
snormal 'ICON'            snormal tresword
snormal 'IMPURE'          snormal tresword
snormal 'INACTIVE'        snormal tresword
snormal 'LANGUAGE'        snormal tresword
snormal 'LISTBOX'         snormal tresword
snormal 'LOADONCALL'      snormal tresword
snormal 'LTEXT'           snormal tresword
snormal 'MENU'            snormal tresword
snormal 'MENUBARBREAK'    snormal tresword
snormal 'MENUBREAK'       snormal tresword
snormal 'MENUEX'          snormal tresword
snormal 'MENUITEM'        snormal tresword
snormal 'MESSAGETABLE'    snormal tresword
snormal 'MOVEABLE'        snormal tresword
snormal 'NOINVERT'        snormal tresword
snormal 'NONDISCARDABLE'  snormal tresword
snormal 'NONSHARED'       snormal tresword
snormal 'POPUP'           snormal tresword
snormal 'PRELOAD'         snormal tresword
snormal 'PRODUCTVERSION'  snormal tresword
snormal 'PURE'            snormal tresword
snormal 'PUSHBOX'         snormal tresword
snormal 'PUSHBUTTON'      snormal tresword
snormal 'RADIOBUTTON'     snormal tresword
snormal 'RCDATA'          snormal tresword
snormal 'RTEXT'           snormal tresword
snormal 'SCROLLBAR'       snormal tresword
snormal 'SEPARATOR'       snormal tresword
snormal 'SHARED'          snormal tresword
snormal 'SHIFT'           snormal tresword
snormal 'STATE3'          snormal tresword
snormal 'STRINGTABLE'     snormal tresword
snormal 'STYLE'           snormal tresword
snormal 'USERBUTTON'      snormal tresword
snormal 'VALUE'           snormal tresword
snormal 'VERSION'         snormal tresword
snormal 'VERSIONINFO'     snormal tresword
snormal 'VIRTKEY'         snormal tresword

// numbers
snormal [1-9][0-9]*                            snormal  tinteger
snormal 0x[0-9A_F]+                            snormal  tinteger
snormal [1-9][0-9]*\.[0-9]*                    snormal  tfloat
snormal [1-9][0-9]*{\.[0-9]+}|e{[\+\-]}|[0-9]+ snormal  tfloat

//idents
snormal   [a-z_A-Z][a-z_A-Z0-9]*  snormal   tident

//white space
snormal #32*                      snormal   twhitespace

//comments
snormal     //                      scomment1  tcomment
scomment1   [#1-#255]*              snormal    tcomment
scomment1  $                        snormal   tcomment

snormal   /\*                     scomment2 tcomment
scomment2 [^\*]*                  scomment2 tcomment
scomment2 \*[^/]                  scomment2 tcomment
scomment2 [\*]*/                  snormal   tcomment

//strings
snormal    \"                     sstring1   tstring
sstring1   [^\"]*                 sstring1   tstring
sstring1   \"                     snormal    tstring
sstring1   \"\"                   sstring1   tstring
sstring1   $                      snormal    tstring

snormal    \'                     sstring2   tstring
sstring2   [^\']*                 sstring2   tstring
sstring2   \'                     snormal    tstring
sstring2   \'\'                   sstring2   tstring
sstring2   $                      snormal    tstring

//directives
snormal  \#                       sdirective tdirective
sdirective [#1-#255]*             snormal    tdirective
sdirective $                      snormal    tdirective
